import { createStore } from "vuex";
import createPersistedState from "vuex-persistedstate";
import dayjs from "dayjs";
const store = createStore({
  plugins: [createPersistedState()],
  state: () => ({
    token: "eyJhbGciOiJIUzUxMiJ9.eyJsb2dpbl91c2VyX2tleSI6IjllNTU3NDk1LWQyOGQtNDMyNy1hYTBjLTdjOTk2OTk5NTk1YiJ9.GvGgys5erlFYJMLEhk2S1e7W_9CKDJohfXfW8fZpitkpZ8RWni5u9VvTGjl8dhD1916s-4MTM_7TsNaTNwsuPg",
    userData: {
      schoolName:""
    },
    carType: "0",
    suject: "0",
  }),
  getters: {
    getSchoolName(state){
      return state.userData.schoolName

    },
    getCarType(state) {
      return state.carType;
    },
    getToken(state) {
      return state.token;
    },
    getUserData(state) {
      return state.userData;
    },
    getIsVip(state): Boolean {
      const userTime: number = dayjs(store.getters.getUserData.expireTime).valueOf();
      const currentTime: number = dayjs().valueOf();
      return (userTime - currentTime) > 0
      // return true
    }
  },
  mutations: {
    setSuject(state, suject: string) {
      state.suject = suject;
    },
    setCatType(state, carType: string) {
      state.carType = carType;
    },
    setToken(state, token: string) {
      state.token = token;
    },
    setUserData(state, userData: object) {
      state.userData = userData;
    },
  },
});

export default store;
